#ifndef MYGLHEADER_H
#define MYGLHEADER_H

#include <wx/wx.h>
#include <wx/glcanvas.h>
#include <GL/glu.h>

#define NO_MOVE 1.0e10
#define NO_CHANGE -1.0
#define VERY_SMALL 1.0e-6
#define VERY_BIG 1.0e10

#define	GLmes() {\
	GLenum errorCode = glGetError();\
		if (errorCode != GL_NO_ERROR) {\
			wxLogError("glGetError: %s, in file: %s, lines %d",\
			gluErrorString(errorCode), __FILE__, __LINE__);\
		}\
}\

#ifdef DEBUG
#define	GLmesDebug() {\
	GLenum errorCode = glGetError();\
		if (errorCode != GL_NO_ERROR) {\
			wxLogError("glGetError: %s, in file: %s, lines %d",\
			gluErrorString(errorCode), __FILE__, __LINE__);\
		}\
}
#else
#define	GLmesDebug()
#endif

#endif //MYGLHEADER
