#include "mylabel.h"

#if wxCHECK_VERSION(2, 6, 0)
myLabel::myLabel(wxWindow* parent, int width) : wxStaticText(parent, -1, wxT(""), wxDefaultPosition, wxSize(width, 20), wxALIGN_CENTRE) {
	SetProperties();	
}

void myLabel::SetProperties() {
	SetWindowStyle(wxSIMPLE_BORDER);
	SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
//	SetSize(60, 20);
}

#else
myLabel::myLabel(wxWindow* parent, int width) : wxStaticText(parent, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE) {
	int osv, mav, miv;
	osv = wxGetOsVersion(&mav, &miv);
	SetProperties();	
	SetWindowStyle(wxSIMPLE_BORDER);
	if (osv != wxWIN386 && osv != wxWIN95 && osv != wxWIN32S) {
		SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
	}
	SetSize(width, 20);
}

void myLabel::SetProperties() {
}
#endif
