#ifndef OTHERPAGE_H
#define OTHERPAGE_H

#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include "myslider.h"
#include "mylabel.h"

class OtherPage : public wxScrolledWindow {
public:
    OtherPage(wxWindow* parent);

	bool Save(wxTextOutputStream &out);
	bool Load(wxTextInputStream &in);

private:
    void SetProperties();
    void DoLayout();

	myLabel *label1;
	myLabel *label2;
	myLabel *label3;
	myLabel *label4;

	wxTextCtrl *nickname_jp;
	wxTextCtrl *familyname_jp;
	wxTextCtrl *nickname_en;
	wxTextCtrl *familyname_en;

	myLabel *label5;
	myLabel *label6;
	myLabel *label7;

	wxSpinSlider *punch_manip;
	wxSpinSlider *speed_manip;
	wxSpinSlider *stamina_manip;

	myLabel *label8;
	myLabel *label9;
	myLabel *label10;
	myLabel *label11;

	wxSpinSlider *damage_restore;
	wxSpinSlider *damage_max;
	wxSpinSlider *cyanosis_restore;
	wxSpinSlider *cyanosis_max;

	myLabel *label12;
	myLabel *label13;
	myLabel *label14;
	myLabel *label15;
	myLabel *label16;

	wxSpinSlider *block_absorb;
	wxSpinSlider *body_strength;
	wxSpinSlider *liver_strength;
	wxSpinSlider *face_strength;
	wxSpinSlider *jaw_strength;
};

#endif // OTHERPAGE_H
