#include "basicpage.h"

BasicPage::BasicPage(wxWindow* parent) : wxScrolledWindow(parent, -1) {
	SetProperties();
	DoLayout();
}

void BasicPage::SetProperties() {
	label1 = new myLabel(this, wxT(""));
	label2 = new myLabel(this, wxT("⡼"));

	ScreenSize = new myCBox(this);
	ScreenSize->Append(wxT(" 640x480"));
	ScreenSize->Append(wxT(" 800x600"));
	ScreenSize->Append(wxT("1024x768"));
	ScreenSize->Append(wxT(" 320x240"));
	ScreenSize->Append(wxT(" 400x300"));
	ScreenSize->Append(wxT(" 512x384"));

	ScreenMode = new myCBox(this);
	ScreenMode->Append(wxT("ɥ"));
	ScreenMode->Append(wxT("ե륹꡼"));

	label3 = new myLabel(this, wxT("ȿ"));
	label4 = new myLabel(this, wxT("եޥå"));
	label5 = new myLabel(this, wxT("ͥ"));
	label6 = new myLabel(this, wxT("Хåե"));

	SoundFreq = new myCBox(this);
	SoundFreq->Append(wxT("44100"));
	SoundFreq->Append(wxT("22050"));
	SoundFreq->Append(wxT("11025"));
	SoundFreq->Append(wxT("48000"));
	SoundFreq->Append(wxT("32000"));

	SoundForm = new myCBox(this);
	SoundForm->Append(wxT("16 bit"));
	SoundForm->Append(wxT(" 8 bit"));

	SoundChan = new myCBox(this);
	SoundChan->Append(wxT("ƥ쥪"));
	SoundChan->Append(wxT("Υ"));

	SoundBuff = new myCBox(this);
	SoundBuff->Append(wxT("4096"));
	SoundBuff->Append(wxT("2048"));
	SoundBuff->Append(wxT("1024"));
	SoundBuff->Append(wxT(" 512"));
	SoundBuff->Append(wxT("8182"));

	label7 = new myLabel(this, wxT("BGMܥ塼"));
	label8 = new myLabel(this, wxT("̲ܥ塼"));

	BGMVolume = new mySlider(this, -8, 128, 8);
	SEVolume = new mySlider(this, -8, 128, 8);

	label9 = new myLabel(this,wxT(""));
	label10 = new myLabel(this,wxT("ѻե"));
	label10_2 = new myLabel(this,wxT("ݥꥴե"));

	Lang = new myCBox(this);
	Lang->Append(wxT("ܸ()"));
	Lang->Append(wxT("ܸ()"));
	Lang->Append(wxT("Ѹ"));

	Font = new myCBox(this);
	Font->Append(wxT("ӥåȥޥå"));
	Font->Append(wxT("ȥ롼"));

	PFont = new myCBox(this);
	PFont->Append(wxT("Ѥʤ"));
	PFont->Append(wxT("Ѥ"));

	label11 = new myLabel(this, wxT("ʬ"));
	label24 = new myLabel(this, wxT("ɽ"));
	label12 = new myLabel(this, wxT(""));
	label13 = new myLabel(this, wxT("ط"));
	label23 = new myLabel(this, wxT("󥰹"));
	label14 = new myLabel(this, wxT("ե륿"));
	label15 = new myLabel(this, wxT("̾ե륿"));
	label16 = new myLabel(this, wxT("åץե졼"));

	Partition = new mySlider(this, 2, 10, 1);

	FaceStyle = new myCBox(this);
	FaceStyle->Append(wxT("ʤ"));
	FaceStyle->Append(wxT("ƥ"));
	FaceStyle->Append(wxT("ݥꥴ"));
 	FaceStyle->SetSize(160,20);

	Shadow = new myCBox(this);
	Shadow->Append(wxT("OFF"));
	Shadow->Append(wxT("ON"));
 	Shadow->SetSize(160,20);

	BackGround = new myCBox(this);
	BackGround->Append(wxT("OFF"));
	BackGround->Append(wxT("졼"));
	BackGround->Append(wxT("ƥ"));

	Ads = new myCBox(this);
	Ads->Append(wxT("OFF"));
	Ads->Append(wxT("ON"));

	MagFilter = new myCBox(this);
	MagFilter->Append(wxT("˥쥹"));
	MagFilter->Append(wxT("˥"));

	MinFilter = new myCBox(this);
	MinFilter->Append(wxT("˥쥹"));
	MinFilter->Append(wxT("˥"));

	SkipFrame = new mySlider(this, 1, 5, 1);

	label17 = new myLabel(this, wxT(""));
	label18 = new myLabel(this, wxT("󥰥"));
	label19 = new myLabel(this, wxT("뤵"));
	DefaultView = new myCBox(this);
	DefaultView->Append(wxT("ɥӥ塼1"));
	DefaultView->Append(wxT("ɥӥ塼2"));
	DefaultView->Append(wxT("Хåӥ塼1"));
	DefaultView->Append(wxT("Хåӥ塼2"));
	DefaultView->Append(wxT("ȥåץӥ塼1"));
	DefaultView->Append(wxT("ȥåץӥ塼2"));
	DefaultView->Append(wxT("ܥӥ塼1"));
	DefaultView->Append(wxT("ܥӥ塼2"));

	DefaultView->Append(wxT("ӥ塼1"));
	DefaultView->Append(wxT("ӥ塼2"));
	DefaultView->Append(wxT("ӥ塼3"));
	DefaultView->Append(wxT("ӥ塼4"));
	DefaultView->Append(wxT("ӥ塼5"));
	DefaultView->Append(wxT("ӥ塼6"));
	DefaultView->Append(wxT("ӥ塼7"));
	DefaultView->Append(wxT("ӥ塼8"));

	Angle = new mySlider(this, -90, 90, 5);
	Brightness = new mySlider(this, -100, 100, 5);

	label20 = new myLabel(this, wxT("åץץ˥"));
	label21 = new myLabel(this, wxT("åץץ쥤"));
	label22 = new myLabel(this, wxT("åץ"));

	SkipOpening = new myCBox(this);
	SkipOpening->Append(wxT("OFF"));
	SkipOpening->Append(wxT("ON"));

	SkipReplay = new myCBox(this);
	SkipReplay->Append(wxT("OFF"));
	SkipReplay->Append(wxT("ON"));

	SkipDown = new myCBox(this);
	SkipDown->Append(wxT("OFF"));
	SkipDown->Append(wxT("ON"));
}

void BasicPage::DoLayout() {
	wxBoxSizer *tsizer = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *tsizer1 = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer *tsizer2 = new wxBoxSizer(wxVERTICAL);
	
	wxStaticBoxSizer *bsizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
	wxStaticBoxSizer *bsizer2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
	wxStaticBoxSizer *bsizer3 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
	wxStaticBoxSizer *bsizer4 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ȥե")), wxVERTICAL);
	wxStaticBoxSizer *bsizer5 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ɽ")), wxVERTICAL);
	wxStaticBoxSizer *bsizer6 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
 	wxStaticBoxSizer *bsizer7 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("¾")), wxVERTICAL);

	wxBoxSizer *bsizer11 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer12 = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer21 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer22 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer23 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer24 = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer31 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer32 = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer41 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer42 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer43 = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer51 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer52 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer53 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer54 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer55 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer56 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer57 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer58 = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer61 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer62 = new wxBoxSizer(wxHORIZONTAL);
  	wxBoxSizer *bsizer63 = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer71 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer72 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer73 = new wxBoxSizer(wxHORIZONTAL);

 	tsizer->Add(tsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer->Add(tsizer2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);

 	tsizer1->Add(bsizer1, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer1->Add(bsizer5, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer1->Add(bsizer4, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer2->Add(bsizer2, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer2->Add(bsizer3, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer2->Add(bsizer6, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer2->Add(bsizer7, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);

 	bsizer1->Add(bsizer11, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer1->Add(bsizer12, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer2->Add(bsizer21, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer2->Add(bsizer22, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer2->Add(bsizer23, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer2->Add(bsizer24, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer3->Add(bsizer31, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer3->Add(bsizer32, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer4->Add(bsizer41, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer4->Add(bsizer42, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer4->Add(bsizer43, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer5->Add(bsizer51, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer5->Add(bsizer58, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer5->Add(bsizer52, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer5->Add(bsizer53, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer5->Add(bsizer57, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer5->Add(bsizer54, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer5->Add(bsizer55, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer5->Add(bsizer56, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer6->Add(bsizer61, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer6->Add(bsizer62, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer6->Add(bsizer63, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer7->Add(bsizer71, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer7->Add(bsizer72, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer7->Add(bsizer73, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

	bsizer11->Add(label1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer11->Add(ScreenSize, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer12->Add(label2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer12->Add(ScreenMode, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	bsizer21->Add(label3, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer21->Add(SoundFreq, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer22->Add(label4, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer22->Add(SoundForm, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer23->Add(label5, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer23->Add(SoundChan, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer24->Add(label6, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer24->Add(SoundBuff, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	bsizer31->Add(label7, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer31->Add(BGMVolume, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer32->Add(label8, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer32->Add(SEVolume, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	bsizer41->Add(label9, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer41->Add(Lang, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer42->Add(label10, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer42->Add(Font, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer43->Add(label10_2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer43->Add(PFont, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	bsizer51->Add(label11, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer51->Add(Partition, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer58->Add(label24, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer58->Add(FaceStyle, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer52->Add(label12, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer52->Add(Shadow, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer53->Add(label13, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer53->Add(BackGround, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer57->Add(label23, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer57->Add(Ads, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer54->Add(label14, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer54->Add(MagFilter, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer55->Add(label15, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer55->Add(MinFilter, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer56->Add(label16, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer56->Add(SkipFrame, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	bsizer61->Add(label17, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer61->Add(DefaultView, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer62->Add(label18, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer62->Add(Angle, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer63->Add(label19, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer63->Add(Brightness, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	bsizer71->Add(label20, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer71->Add(SkipOpening, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer72->Add(label21, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer72->Add(SkipReplay, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer73->Add(label22, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer73->Add(SkipDown, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	SetSizer(tsizer);
 	tsizer->SetVirtualSizeHints(this);
	FitInside();
	Layout(); 
}

void BasicPage::SetDefault() {
	ScreenSize->SetSelection(0);
	ScreenMode->SetSelection(0);

	SoundFreq->SetSelection(0);
	SoundForm->SetSelection(0);
	SoundChan->SetSelection(0);
	SoundBuff->SetSelection(0);

	BGMVolume->SetValue(-8);
	SEVolume->SetValue(-8);
	
	Lang->SetSelection(0);
	Font->SetSelection(1);
	PFont->SetSelection(1);

	Partition->SetValue(6);
	FaceStyle->SetSelection(2);
	Shadow->SetSelection(1);
	BackGround->SetSelection(2);
	Ads->SetSelection(1);
	MagFilter->SetSelection(1);
	MinFilter->SetSelection(0);
	SkipFrame->SetValue(1);

	DefaultView->SetSelection(0);
	Angle->SetValue(10);
	Brightness->SetValue(0);	

	SkipOpening->SetSelection(0);
	SkipReplay->SetSelection(0);
	SkipDown->SetSelection(0);
}

void BasicPage::SetHigherSpec() {
	ScreenSize->SetSelection(2);
	ScreenMode->SetSelection(0);

	Partition->SetValue(10);
	FaceStyle->SetSelection(2);
	Shadow->SetSelection(1);
	BackGround->SetSelection(2);
	Ads->SetSelection(1);
	SkipFrame->SetValue(1);

	PFont->SetSelection(1);

//	SkipOpening->SetSelection(0);
//	SkipReplay->SetSelection(0);
}

void BasicPage::SetHighSpec() {
	ScreenSize->SetSelection(1);
	ScreenMode->SetSelection(0);

	Partition->SetValue(9);
	FaceStyle->SetSelection(2);
	Shadow->SetSelection(1);
	BackGround->SetSelection(2);
	Ads->SetSelection(1);
	SkipFrame->SetValue(1);

	PFont->SetSelection(1);

//	SkipOpening->SetSelection(0);
//	SkipReplay->SetSelection(0);
}

void BasicPage::SetMiddleSpec() {
	ScreenSize->SetSelection(0);
	ScreenMode->SetSelection(0);

	Partition->SetValue(6);
	FaceStyle->SetSelection(2);
	Shadow->SetSelection(1);
	BackGround->SetSelection(2);
	Ads->SetSelection(1);
	SkipFrame->SetValue(1);

	PFont->SetSelection(1);

//	SkipOpening->SetSelection(0);
//	SkipReplay->SetSelection(0);
}

void BasicPage::SetLowSpec() {
	ScreenSize->SetSelection(0);
	ScreenMode->SetSelection(0);

	Partition->SetValue(3);
	FaceStyle->SetSelection(1);
	Shadow->SetSelection(0);
	BackGround->SetSelection(1);
	Ads->SetSelection(1);
	SkipFrame->SetValue(1);

	PFont->SetSelection(0);

	SkipOpening->SetSelection(1);
//	SkipReplay->SetSelection(1);
}

void BasicPage::SetLowerSpec() {
	ScreenSize->SetSelection(0);
	ScreenMode->SetSelection(1);

	Partition->SetValue(2);
	FaceStyle->SetSelection(1);
	Shadow->SetSelection(0);
	BackGround->SetSelection(0);
	Ads->SetSelection(0);
	SkipFrame->SetValue(2);

	PFont->SetSelection(0);

	SkipOpening->SetSelection(1);
	SkipReplay->SetSelection(1);
}

bool BasicPage::Save(wxTextOutputStream &out) {
	wxString str;

	str.Printf( "\n#Screen Config\n");
	out << str;
	str.Printf( "#Screeen Size  0 : 640x480  1 : 800x600  2 : 1024x768\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", ScreenSize->GetSelection());
	out << str;
	str.Printf( "#Screen Mode  0 : Window Mode  1 : Full Screen Mode\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", ScreenMode->GetSelection());
	out << str;

	str.Printf( "\n#Sound Config\n");
	out << str;
	str.Printf( "#Sound Frequency  0 : 44100  1 : 22050  2 : 11025  3 : 48000  4 : 32000\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", SoundFreq->GetSelection());
	out << str;
	str.Printf( "#Sound Format  0 : 16bit  1 : 8bit\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", SoundForm->GetSelection());
	out << str;
	str.Printf( "#Sound Channel  0 : Stereo  1 : Mono\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", SoundChan->GetSelection());
	out << str;
	str.Printf( "#Sound Buffer Size  0 : 4096  1 : 2048  2 : 1024  3 : 512  4 : 8182\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", SoundBuff->GetSelection());
	out << str;

	str.Printf( "\n#BGM Volume  -8-128\n");
	out << str;
	str.Printf( "#Default -8\n");
	out << str;
	str.Printf( "%d\n", BGMVolume->GetValue());
	out << str;

	str.Printf( "\n#Sound Effect  Volume -8-128\n");
	out << str;
	str.Printf( "#Default -8\n");
	out << str;
	str.Printf( "%d\n", SEVolume->GetValue());
	out << str;

	str.Printf( "\n#Language  0 : Japanese Kanji  1 : Japanese Kana  2 : English\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", Lang->GetSelection());
	out << str;

	str.Printf( "\n#Make Alphabet Font from TTF  0 : No  1 : Yes\n");
	out << str;
	str.Printf( "#Default 1\n");
	out << str;
	str.Printf( "%d\n", Font->GetSelection());
	out << str;

	str.Printf( "#Use Polygon Font  0 : No  1 : Yes\n");
	out << str;
	str.Printf( "#Default 1\n");
	out << str;
	str.Printf( "%d\n", PFont->GetSelection());
	out << str;

	str.Printf( "\n#Expression Accuracy Config\n");
	out << str;
	str.Printf( "#Partition Number  2-10\n");
	out << str;
	str.Printf( "#Default 9\n");
	out << str;
	str.Printf( "%d\n", Partition->GetValue());	
	out << str;

	str.Printf( "#Face Style  0 : None  1 : Texture  2 : Polygon\n");
	out << str;
	str.Printf( "#Default 2\n");
	out << str;
	str.Printf( "%d\n", FaceStyle->GetSelection());
	out << str;

	str.Printf( "#Shadows  1 : ON  0 : OFF\n");
	out << str;
	str.Printf( "#Default 1\n");
	out << str;
	str.Printf( "%d\n", Shadow->GetSelection());
	out << str;

	str.Printf( "#BackGround  0 : OFF  1 : Gray  2 : Texture\n");
	out << str;
	str.Printf( "#Default 2\n");
	out << str;
	str.Printf( "%d\n", BackGround->GetSelection());
	out << str;

	str.Printf( "#Ring Ad's  1 : ON  0 : OFF\n");
	out << str;
	str.Printf( "#Default 1\n");
	out << str;
	str.Printf( "%d\n", Ads->GetSelection());
	out << str;

	str.Printf( "#Texture Magnification Filter  0 : Nearest  1 : Linear\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", MagFilter->GetSelection());
	out << str;
	str.Printf( "#Texture Minification Filter  0 : Nearest  1 : Linear\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", MinFilter->GetSelection());
	out << str;

	str.Printf( "#Skip Frame  1-5\n");
	out << str;
	str.Printf( "#Default 1\n");
	out << str;
	str.Printf( "%d\n", SkipFrame->GetValue());	
	out << str;

	str.Printf( "\n#Camera Config\n");
	out << str;
	str.Printf( "#Default View  0 : SideView1  1 : SideView2  2 : BackView1  3 : BackView2\n");
	out << str;
	str.Printf( "#              4 : TopView1  5 : Top View 2  6 : BoxerView1  7 : BoxerView2\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", DefaultView->GetSelection());	
	out << str;

	str.Printf( "#Angle  -90-90\n");
	out << str;
	str.Printf( "#Default 10\n");
	out << str;
	str.Printf( "%d\n", Angle->GetValue());	
	out << str;

	str.Printf( "#Brightness  -100-100\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", Brightness->GetValue());	
	out << str;

	str.Printf( "\n#Skip Opening  0 : No  1 : Yes\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", SkipOpening->GetSelection());	
	out << str;

	str.Printf( "#Skip Replay  0 : No  1 : Yes\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", SkipReplay->GetSelection());	
	out << str;

	str.Printf( "#Skip Down  0 : No  1 : Yes\n");
	out << str;
	str.Printf( "#Default 0\n");
	out << str;
	str.Printf( "%d\n", SkipDown->GetSelection());	
	out << str;

	return true;
}

bool BasicPage::Load(wxTextInputStream &in) {
	wxString str;
	str = NextLine(in);
	ScreenSize->SetSelection(atoi(str));
	str = NextLine(in);
	ScreenMode->SetSelection(atoi(str));

	str = NextLine(in);
	SoundFreq->SetSelection(atoi(str));
	str = NextLine(in);
	SoundForm->SetSelection(atoi(str));
	str = NextLine(in);
	SoundChan->SetSelection(atoi(str));
	str = NextLine(in);
	SoundBuff->SetSelection(atoi(str));
	
	str = NextLine(in);
	BGMVolume->SetValue(atoi(str));
	str = NextLine(in);
	SEVolume->SetValue(atoi(str));

	str = NextLine(in);
	Lang->SetSelection(atoi(str));
	str = NextLine(in);
	Font->SetSelection(atoi(str));
	str = NextLine(in);
	PFont->SetSelection(atoi(str));

	str = NextLine(in);
	Partition->SetValue(atoi(str));
	str = NextLine(in);
	FaceStyle->SetSelection(atoi(str));
	str = NextLine(in);
	Shadow->SetSelection(atoi(str));
	str = NextLine(in);
	BackGround->SetSelection(atoi(str));
	str = NextLine(in);
	Ads->SetSelection(atoi(str));
	str = NextLine(in);
	MagFilter->SetSelection(atoi(str));
	str = NextLine(in);
	MinFilter->SetSelection(atoi(str));
	str = NextLine(in);
	SkipFrame->SetValue(atoi(str));

	str = NextLine(in);
	DefaultView->SetSelection(atoi(str));
	str = NextLine(in);
	Angle->SetValue(atoi(str));
	str = NextLine(in);
	Brightness->SetValue(atoi(str));

	str = NextLine(in);
	SkipOpening->SetSelection(atoi(str));
	str = NextLine(in);
	SkipReplay->SetSelection(atoi(str));
 	str = NextLine(in);
	SkipDown->SetSelection(atoi(str));

	return true;
}

wxString NextLine(wxTextInputStream &in) {
	static wxString str;
	static int i;
	i = 0;
	do {
		str = in.ReadLine();
		if (!str.IsNull() && str.c_str()[0] !='#') {
			break;		
		}
		if (str.IsNull()) {
			i++;
		}
	} while(i < 1000);
	return str;
}
