#ifndef CONTROLPAGE_H
#define CONTROLPAGE_H

#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/combobox.h>
#include "myslider.h"
#include "mylabel.h"
#include "mycbox.h"
#include "mytctrl.h"

class ControlPage : public wxScrolledWindow {
public:
    ControlPage(wxWindow* parent);

	void SetDefault();

	bool Save(wxTextOutputStream &out);
	bool Load(wxTextInputStream &in);

private:
    void SetProperties();
    void DoLayout();

	myLabel *label1;
	myLabel *label2;
	myLabel *label3;

	myCBox *Player1Mode;
	myCBox *Player2Mode;
	myCBox *UseMouse;

	myLabel *label25;
	myTCtrl *GoNext;

	myLabel *label4;
	myLabel *label5;
	myLabel *label6;
	myLabel *label7;
	myLabel *label8;
	myLabel *label9;
	myLabel *label10;

	myTCtrl *KB1LeftOffense;
	myTCtrl *KB1RightOffense;
	myTCtrl *KB1Defense;
	myTCtrl *KB1Forward;
	myTCtrl *KB1Back;
	myTCtrl *KB1Right;
	myTCtrl *KB1Left;

	myLabel *label11;
	myLabel *label12;
	myLabel *label13;
	myLabel *label14;
	myLabel *label15;
	myLabel *label16;
	myLabel *label17;

	myTCtrl *KB2LeftOffense;
	myTCtrl *KB2RightOffense;
	myTCtrl *KB2Defense;
	myTCtrl *KB2Forward;
	myTCtrl *KB2Back;
	myTCtrl *KB2Right;
	myTCtrl *KB2Left;

	myLabel *label18;
	myLabel *label19;
	myLabel *label20;
	myLabel *label21;
	myLabel *label22;
	myLabel *label23;
	myLabel *label24;

	myTCtrl *KB3LeftOffense;
	myTCtrl *KB3RightOffense;
	myTCtrl *KB3Defense;
	myTCtrl *KB3Forward;
	myTCtrl *KB3Back;
	myTCtrl *KB3Right;
	myTCtrl *KB3Left;
};

#endif // CONTROLPAGE_H
