#include "mylabel.h"

#if wxCHECK_VERSION(2, 6, 0)
myLabel::myLabel(wxWindow* parent, const wxString &label)
	 : wxStaticText(parent, -1, label, wxDefaultPosition, wxSize(120, 20), wxALIGN_CENTRE) {
	SetProperties();
}

void myLabel::SetProperties() {
	SetWindowStyle(wxSIMPLE_BORDER);
	SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
}

#else
myLabel::myLabel(wxWindow* parent, const wxString &label)
	 : wxStaticText(parent, -1, label, wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE) {
	SetProperties();
}

void myLabel::SetProperties() {
	int osv, mav, miv;
	osv = wxGetOsVersion(&mav, &miv);
	SetWindowStyle(wxSIMPLE_BORDER);
	if (osv != wxWIN386 && osv != wxWIN95 && osv != wxWIN32S) {
		SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
	}
	SetSize(120, 20);
}
#endif


#if wxCHECK_VERSION(2, 6, 0)
myButton::myButton(wxWindow* parent, const wxString &label)
	 : wxButton(parent, -1, label, wxDefaultPosition, wxSize(120, 20), wxALIGN_CENTRE) {
	SetProperties();
}

void myButton::SetProperties() {
	SetWindowStyle(wxSIMPLE_BORDER);
	SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
}

#else
myButton::myButton(wxWindow* parent, const wxString &label)
	 : wxButton(parent, -1, label, wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE) {
	SetProperties();
}

void myButton::SetProperties() {
	int osv, mav, miv;
	osv = wxGetOsVersion(&mav, &miv);
	SetWindowStyle(wxSIMPLE_BORDER);
	if (osv != wxWIN386 && osv != wxWIN95 && osv != wxWIN32S) {
		SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
	}
	SetSize(120, 20);
}
#endif

