#include "mynotebook.h"

myNotebook::myNotebook(wxWindow *parent) : wxNotebook(parent, ON_NOTEBOOK_ID) {
	SetProperties();
    DoLayout();		   
}

void myNotebook::SetProperties() {
	bpage = new BasicPage(this);
	npage = new NetPage(this);
	cpage = new ControlPage(this);
	mpage = new MatchPage(this);
	ppage = new ManipPage(this);
	apage= new AudioPage(this);
	vpage = new VisualPage(this);
	gpage = new BoxerPage(this);
	tpage = new ThinkPage(this);
}		

void myNotebook::DoLayout() {
	AddPage(bpage, "基本");
	AddPage(npage, "通信");
	AddPage(cpage, "操作");
	AddPage(mpage, "試合");
	AddPage(ppage, "補整");
	AddPage(apage, "音声");
	AddPage(vpage, "画像");
	AddPage(gpage, "ジム");
	AddPage(tpage, "作戦");
}		
