#ifndef MYSLIDER_H
#define MYSLIDER_H

#include <wx/wx.h>
#include <wx/spinctrl.h>

class mySlider : public wxPanel {
public:
    mySlider(wxWindow* parent, int min_value, int max_value, int change_value);
	int GetValue() const {return spin->GetValue();}
	void SetValue(int value);

private:
    void SetProperties(int min_value, int max_value);
    void DoLayout();
	void OnSlider(wxCommandEvent &event);
	void OnText(wxCommandEvent &event);
	void OnSpin(wxSpinEvent &event);
	void SetSlider();
	void OnSpinCtrlUp(wxSpinEvent &event);
	void OnSpinCtrlDown(wxSpinEvent &event);

	wxSlider *slider;
	wxSpinCtrl *spin;
	int change;
	DECLARE_EVENT_TABLE()
};

enum {
	ON_SPINSLIDER_ID,
	ON_SPINSLIDERCTRL_ID
};

#endif // MYSLIDER_H
