#ifndef NETPAGE_H
#define NETPAGE_H

#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/combobox.h>
#include "mylabel.h"
#include "mycbox.h"
#include "mytctrl.h"


class NetPage : public wxScrolledWindow {
public:
    NetPage(wxWindow* parent);

	void SetDefault();

	bool Save(wxTextOutputStream &out);
	bool Load(wxTextInputStream &in);

private:
    void SetProperties();
    void DoLayout();

	myLabel *label1;
	myLabel *label2;
	myLabel *label3;
	myLabel *label4;
	myLabel *label5;
	myLabel *label6;
	myLabel *label7;
	myLabel *label8;

	myInput *UserName;
	myInput *HostName;
	myInput *HostCGI;
	myInput *MatchMakeCGI;
	myInput *LobbyCGI;

	myInput *Port;
	myInput *PortUDP;
	myCBox *LobbyMode;
};


#endif 	// NETPAGE_H
