#ifndef THINKPAGE_H
#define THINKPAGE_H

#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/combobox.h>
#include "myslider.h"
#include "mylabel.h"
#include "mycbox.h"
#include "mytctrl.h"
#include "myfileselect.h"

class ThinkPage : public wxScrolledWindow {
public:
    ThinkPage(wxWindow* parent);

	void SetDefault();

	bool SaveThinkCf(wxTextOutputStream &out);
	bool SaveThink();
	bool LoadThinkCf(wxTextInputStream &in);
	bool LoadThink();

private:
    void SetProperties();
    void DoLayout();
	void OnSelect(wxCommandEvent& event);

	myLabel *labelf;
	myFileSelect *ThinkCf;

	myLabel *label[15];
	myFileSelect *Think[15];

	DECLARE_EVENT_TABLE()
};

#endif // THINKPAGE_H
