#include "game.h"

Game::Game(int argc, char* argv[]) {
/* ȂACRŗ̂ŏĂ */
#ifdef __BORLANDC__
_control87(MCW_EM,MCW_EM);
#endif

/* EBhE𒆉ɂA
ȂBCCƋ@\Ȃ() */ 
	putenv("SDL_VIDEO_CENTERED=1");

/* R[h̕ϊp */
#ifdef USE_BABEL
	babel::init_babel();
#else
	sjis2uni_making_table();
#endif

/* ݒt@CɂRtBO */
	Config();

/* ͂Ƃ */
#ifdef SWAP_INTERVAL_OFF
	wglSwapIntervalEXT_FUNC wglSwapIntervalEXT;
	wglSwapIntervalEXT = (wglSwapIntervalEXT_FUNC) SDL_GL_GetProcAddress("wglSwapIntervalEXT");
	if(wglSwapIntervalEXT != NULL){
		wglSwapIntervalEXT(0);
	}
#endif

/* IvV */
 	show1 = 0; show2 = 0;
	show_interface = 1;

/* vCp */
	if (argc >= 2) {
		if (SelectReplay(SELECT_REPLAY_ARGUMENT, argv[1])) {
			Replay();		
		}
		Quit();
	}

/* I[vjO */
	if (!SkipOpening) {
		Opening();
	} 

//	PeopleMaker();
//	CanvasMaker();	
//	NetworkMatch();
// 	DummyMenu();
 	while(1) {	/* C[` */
		switch (TopMenu()) {
			case 0:	/* Xg[[[h */
				Story();
			break;
			case 1:	/* 1P Xp[ */
				SetKey1P();
				if (SelectBoxer(SELECT_1PSPARRING)) {
					if (Match(SELECT_1PSPARRING)) {
						SaveReplaySelect();
						if (!SkipReplay) {
							Replay();
						}
					}
				}
			break;
			case 2:	/* 2P ΐ@*/
				SetKey2P();
				if (SelectBoxer(SELECT_2PMATCH)) {
					if (Match(SELECT_2PMATCH)) {
						SaveReplaySelect();
						if (!SkipReplay) {
							Replay();
						}
					}
				}
			break;
			case 3:	/* lbgΐ */
				NetworkMatch();
			break;
			case 4:	/* g[jO */
				SetKey1P();
				if (SelectBoxer(SELECT_TRAINING)) {
					Training();
				}
		//		handler2.MakeBoxerSourceFile(boxer2, motion2, boxer2_file);
		//		handler2.MakeBoxerSourceFile(boxer2, motion2, boxer2_file, MAKE_BODY_SOURCE);
		//		handler2.MakeBoxerSourceFile(boxer2, motion2, boxer2_file, MAKE_MOTION_SOURCE);
		//		handler2.MakeBoxerSourceFile(boxer2, motion2, boxer2_file, MAKE_THINK_SOURCE);
		//		handler2.SaveBinBoxerFile(boxer2, motion2, "boxer2.bin");
		//		fprintf(stderr, "size = %d\n", handler2.CalcDataSize(motion2));
			break;	
			case 5:	/* vC */
				SetKey1P();
				if (SelectReplay()) {
					Replay();
				}
			break;	
			case 6:	/* f */
				Demo();
			break;	
			case 7:	/* I */
				Quit();
			break;	
		}	
	}
}


Game::~Game() {
	Quit();
}  

void Game::Quit() {
 	screen.Destroy();	/* XN[I */
	mixer.StopMusic();	/* y~߂ */
	exit(0);	/* Ƃ肠Ă */
	delete this;
}

void Game::TestMatch() {
	int j, k, red, blue, draw;
	red = 0;
	blue = 0;
	draw = 0;
				
	SelectBoxer(SELECT_1PSPARRING);
	for (j = 0; j < 100; j++) {
		fprintf(stderr, "Start Match No.%d\n", j);
		if (MatchSilent(SELECT_1PSPARRING, k)) {
			SaveReplayCycle();
	//		if (!SkipReplay) {
	//			Replay();
	//		}
		}  
		if (match.WhichWin(handler1, handler2) == 2) {
			red++;
		} else if (match.WhichWin(handler1, handler2) == 1) {
			blue++;
		} else {
			draw++;					
		}
		fprintf(stderr, "Match = %d, Red = %d, Blue = %d, Draw = %d\n", j, red, blue, draw);
		fprintf(stderr, "End Match No.%d\n", j);
	}                    
}

void Game::CalcMeters() {
	handler1.RestoreCyanosis(boxer1);
	handler2.RestoreCyanosis(boxer2);
	handler1.CalcCyanosis(boxer1);
	handler2.CalcCyanosis(boxer2);

	handler1.CalcDamage();
	handler2.CalcDamage();
}

void Game::ShowMeters(){
	static GLMaterial meter_color;
	static float r, g, b;
	light2.Off();
	light.Diffuse(1.0, 1.0, 1.0);

 	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	glOrtho (-4.0, 4.0, -3.0, 3.0, -10.0, 10.0);
    glMatrixMode(GL_MODELVIEW);	
	glLoadIdentity();

	meter_color.DefAmbient(0.2, 0.2, 0.2);
	meter_color.DefEmission(0.0, 0.0, 0.0);
	meter_color.DefSpecular(0.0, 0.0, 0.0);
	meter_color.DefShininess(0.0);
	meter_color.Set();

	handler1.RestoreCyanosis(boxer1);
	handler2.RestoreCyanosis(boxer2);
	handler1.CalcCyanosis(boxer1);
	handler2.CalcCyanosis(boxer2);
	if (IsView1()) {
		handler1.CyanosisColor(&r, &g, &b);
		meter_color.Diffuse(r, g, b);	
		cyanosis_meter.ShowFace1();
		if (can_change_mode1) {
			switch (handler1.WhichMode()) {
				case SEMI_AUTO:
					meter_color.Diffuse(1.0, 1.0, 0.0);	
				break;		
				case FULL_AUTO:			
					meter_color.Diffuse(0.0, 0.0, 1.0);	
				break;		
			}
		}
		cyanosis_meter.ShowHead1();

		handler2.CyanosisColor(&r, &g, &b);
		meter_color.Diffuse(r, g, b);	
		cyanosis_meter.ShowFace2();
		if (can_change_mode2) {
			switch (handler2.WhichMode()) {
				case SEMI_AUTO:
					meter_color.Diffuse(1.0, 1.0, 0.0);	
				break;		
				case FULL_AUTO:			
					meter_color.Diffuse(0.0, 0.0, 1.0);	
				break;		
			}
		}
		cyanosis_meter.ShowHead2();
	} else {
		handler1.CyanosisColor(&r, &g, &b);
		meter_color.Diffuse(r, g, b);	
		cyanosis_meter.ShowFace2();
		if (can_change_mode1) {
			switch (handler1.WhichMode()) {
				case SEMI_AUTO:
					meter_color.Diffuse(1.0, 1.0, 0.0);	
				break;		
				case FULL_AUTO:			
					meter_color.Diffuse(0.0, 0.0, 1.0);	
				break;		
			}
		}
		cyanosis_meter.ShowHead2();

		handler2.CyanosisColor(&r, &g, &b);
		meter_color.Diffuse(r, g, b);	
		cyanosis_meter.ShowFace1();	
		meter_color.Diffuse(r, g, b);	
		cyanosis_meter.ShowFace2();
		if (can_change_mode2) {
			switch (handler2.WhichMode()) {
				case SEMI_AUTO:
					meter_color.Diffuse(1.0, 1.0, 0.0);	
				break;		
				case FULL_AUTO:			
					meter_color.Diffuse(0.0, 0.0, 1.0);	
				break;		
			}
		}
		cyanosis_meter.ShowHead1();
	}

	handler1.CalcDamage();
	handler2.CalcDamage();

	meter_color.Specular(meterspec, meterspec, meterspec);
	meter_color.Shininess(128.0);
	if (IsView1()) {
		meter_color.Diffuse(0.0, 0.0, 0.0);	
		damage_meter.Show1First(handler1.TraumDamage());
		meter_color.Diffuse(0.333, 0.0, 0.0);	
		damage_meter.Show1Next(handler1.BodyDamage());
		meter_color.Diffuse(0.666, 0.0, 0.0);	
		damage_meter.Show1Next(handler1.FaceDamage());
		meter_color.Diffuse(1.0, 0.0, 0.0);	
		damage_meter.Show1Next(handler1.BrainDamage());

		meter_color.Diffuse(0.0, 0.0, 0.0);	
		damage_meter.Show2First(handler2.TraumDamage());
		meter_color.Diffuse(0.333, 0.0, 0.0);	
		damage_meter.Show2Next(handler2.BodyDamage());
		meter_color.Diffuse(0.666, 0.0, 0.0);	
		damage_meter.Show2Next(handler2.FaceDamage());
		meter_color.Diffuse(1.0, 0.0, 0.0);	
		damage_meter.Show2Next(handler2.BrainDamage());
	} else {
		meter_color.Diffuse(0.0, 0.0, 0.0);	
		damage_meter.Show2First(handler1.TraumDamage());
		meter_color.Diffuse(0.333, 0.0, 0.0);	
		damage_meter.Show2Next(handler1.BodyDamage());
		meter_color.Diffuse(0.666, 0.0, 0.0);	
		damage_meter.Show2Next(handler1.FaceDamage());
		meter_color.Diffuse(1.0, 0.0, 0.0);	
		damage_meter.Show2Next(handler1.BrainDamage());

		meter_color.Diffuse(0.0, 0.0, 0.0);	
		damage_meter.Show1First(handler2.TraumDamage());
		meter_color.Diffuse(0.333, 0.0, 0.0);	
		damage_meter.Show1Next(handler2.BodyDamage());
		meter_color.Diffuse(0.666, 0.0, 0.0);	
		damage_meter.Show1Next(handler2.FaceDamage());
		meter_color.Diffuse(1.0, 0.0, 0.0);	
		damage_meter.Show1Next(handler2.BrainDamage());
	}

	if (distance > 1.5) {
		meter_color.Diffuse(0.0, 0.9, 0.0);	
	} else if (distance > 1.0) {
		meter_color.Diffuse(0.9, 0.9, 0.0);		
	} else {
		meter_color.Diffuse(0.9, 0.0, 0.0);		
	}
	distance_meter.Show(distance);

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();

	glMatrixMode(GL_MODELVIEW);
	light.Diffuse(0.8, 0.8, 0.8);
	light2.On();
}

void Game::ShowShadow(Boxer &shadow_boxer){
	static GLfloat m[16] = {1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0,
							0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.006, 1.0};
/*	GLfloat dx = 0.0, dy = 0.0, dz = 3.0, dw = 0.0;
	GLfloat ca = 0.0, cb = 0.0, cc = 1.0, cd = -0.005;

    m[0] =  cb * dy + cc * dz;
	m[1] = -ca * dy;
	m[2] = -ca * dz;
	m[3] = -ca * dw;
	
    m[4] = -cb * dx;
	m[5] =  cc * dz + ca * dx;
	m[6] = -cb * dz;
	m[7] = -cb * dw;

    m[8]  = -cc * dx;
	m[9]  = -cc * dy;
	m[10] =  ca * dx + cb * dy;
	m[11] = -cc * dw;

	m[12] = -cd * dx;
	m[13] = -cd * dy;
	m[14] = -cd * dz;
	m[15] =  ca * dx + cb * dy + cc *dz;    */
	
	glPushMatrix();
	glMultMatrixf(m);
//	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glColor3f(0.0, 0.0, 0.0);
	shadow_boxer.CallLists();		
//	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glPopMatrix();
}

void Game::CalcAdjust() {
	float dx, dy, arg, darg;
	nox1 = boxer1.OX();
	noy1 = boxer1.OY();
	not1 = boxer1.OT();
	if (boxer1.OX() > 2.3) {
		nox1 -= 0.01;	
	}
	if (boxer1.OX() < -2.3) {
		nox1 += 0.01;	
	}
	if (boxer1.OY() > 2.3) {
		noy1 -= 0.01;	
	}
	if (boxer1.OY() < -2.3) {
		noy1 += 0.01;	
	}

	nox2 = boxer2.OX();
	noy2 = boxer2.OY();
	not2 = boxer2.OT();
	if (boxer2.OX() > 2.3) {
		nox2 -= 0.01;	
	}
	if (boxer2.OX() < -2.3) {
		nox2 += 0.01;	
	}
	if (boxer2.OY() > 2.3) {
		noy2 -= 0.01;	
	}
	if (boxer2.OY() < -2.3) {
		noy2 += 0.01;	
	}

	if (handler1.AdjustDistance() > 1.0 || handler2.AdjustDistance() > 1.0) {
		nox1 += cos(RAD(not1))*0.015;	
		noy1 -= sin(RAD(not1))*0.015;	
		nox2 += cos(RAD(not2))*0.015;	
		noy2 -= sin(RAD(not2))*0.015;
/*		nox1 -= dx*0.015;	
		noy1 -= dy*0.015;	
		nox2 += dx*0.015;	
		noy2 += dy*0.015;	*/
		if (distance > 2.5 || handler1.IsCounting() || handler2.IsCounting()) {
			handler1.SetAdjustDistance(0.75);
			handler2.SetAdjustDistance(0.75);		
			match.SetCounter(-50);
		}
	} else if (distance < 0.75) {
		nox1 += cos(RAD(not1))*0.005;	
		noy1 -= sin(RAD(not1))*0.005;	
		nox2 += cos(RAD(not2))*0.005;	
		noy2 -= sin(RAD(not2))*0.005;	
/*		nox1 -= dx*0.005;	
		noy1 -= dy*0.005;	
		nox2 += dx*0.005;	
		noy2 += dy*0.005;*/	
	}
 
	dx = nox2 - nox1;
	dy = noy2 - noy1;
	arg = DEG(atan(dy/dx));
	if (dy >= 0.0) {
		if (dx >= 0.0) {
		
		} else {
			arg += 180.0; 		
		}
	} else {
		if (dx >= 0.0) {
			arg += 360.0; 				
		} else {
			arg += 180.0;		
		}	
	}

    darg = arg + 270.0 - not1;
	if (darg >= 180.0) {
		darg -= 360.0;	
	}
	if (darg <= -180.0) {
		darg += 360.0;		
	} 
	not1 += darg* 0.05;
	if (not1 < 0.0) {
		not1+=360.0;	
	}
	if (not1 > 360) {
		not1-=360.0;	
	}

    darg = arg + 90.0 - not2;
	if (darg >= 180.0) {
		darg -= 360.0;	
	}
	if (darg <= -180.0) {
		darg += 360.0;		
	} 
	not2 += darg * 0.05;
	if (not2 < 0.0) {
		not2+=360.0;	
	}
	if (not2 > 360) {
		not2-=360.0;	
	}
}

void Game::GetKeyStates(BoxerHandler &handler) {
	handler.InitKey();
	if (event.IsKeyPressed(handler.ForwardKey())) {
		handler.Forward();	
	} 
	if (event.IsKeyPressed(handler.BackKey())) {
		handler.Back();	
	} 
	if (event.IsKeyPressed(handler.RightKey())) {
		handler.Right();	
	} 
	if (event.IsKeyPressed(handler.LeftKey())) {
		handler.Left();	
	} 
	if (event.IsKeyPressed(handler.LeftOffenseKey())) {
		handler.LeftOffense();	
	} 
	if (event.IsKeyPressed(handler.RightOffenseKey())) {
		handler.RightOffense();	
	} 
	if (event.IsKeyPressed(handler.DefenseKey())) {
		handler.Defense();	
	} 
}

void Game::GetOffenseKeyStates(BoxerHandler &handler) {
	if (event.IsKeyPressed(handler.LeftOffenseKey())) {
		handler.LeftOffense();	
	} 
	if (event.IsKeyPressed(handler.RightOffenseKey())) {
		handler.RightOffense();	
	} 
	if (event.IsKeyPressed(handler.DefenseKey())) {
		handler.Defense();	
	} 
}

void Game::GetMouseStates(BoxerHandler &handler) {
/*	int x, y, x1, y1, x2, y2, yh;
	SDL_GetMouseState(&x, &y);

	x1 = width / 3;
	x2 = x1 * 2;
	y1 = height / 3;
	y2 = y1 * 2;
	yh = height / 2;
	
	if (x > 0 && x < x1) {
		handler.Back();	
		if (y > 0 && y < y1) {
			handler.Left();	
		} else if (y >= y2 && y < height) {	
			handler.Right();		
		}	
	} else if (x >= x1 && x < x2) {
		if (y > 0 && y < y1) {
			handler.Left();	
		} else if (y >= y1 && y < yh) {	
			handler.Defense();	
		} else if (y >= y2 && y < height){
			handler.Right();		
		}	
	} else {
		handler.Forward();	
		if (y > 0 && y < y1) {
			handler.Left();	
		} else if (y >= y2 && y < height) {	
			handler.Right();		
		}	
	}
            */
	if (event.IsMouse1Pressed()) {
		handler.LeftOffense();	
	} 
	if (event.IsMouse2Pressed()) {
		handler.Defense();	
	}  
	if (event.IsMouse3Pressed()) {
		handler.RightOffense();	
	}    
}

void Game::GetOffenseMouseStates() {
	if (use_mouse == 1) {
		GetMouseStates(handler1);	
	} else {
		GetMouseStates(handler2);		
	}
}

void Game::GetComStates(BoxerHandler &handler) {
	handler.InitKey();

	if (handler.IsDownState()) {
		handler.Defense();
		return;
	}

	if (handler.IsWaitState()) {
		if (match.KOCount() - handler.Count() < 2) {
			handler.Defense();
		}
		return;
	}

	if (handler.IsMoveState()) {
		if (random.RandF() > 0.10) {
		 	return;
		}
	}

	if (random.RandF() > 0.90) {
		if (random.RandF() > 0.5) {
			handler.Forward();	
		} else {
			handler.Back();
		}	
		return;	
	}

	if (handler.MoveSpeed() > 1.9) {
		if (random.RandF() > 0.5) {
			handler.Back();
    	} else {
			handler.Defense();
		}
		return;	
	}

	if (handler.SwingSpeed() > 1.6) {
		if (random.RandF() > 0.666) {
			handler.Defense();
		} else if (random.RandF() > 0.5) {
			if (distance < 1.0) {
				handler.Defense();
				handler.Forward();
			} else {
				handler.Defense();
				handler.Back();
			}		
		} else {
				handler.Back();		
		}
		return;	
	}

	if (distance > 1.5) {
		handler.Forward();
		return;		
	}

	if (distance  < 0.75) {
		handler.RightOffense();	
		handler.LeftOffense();	
		return;
	}

	if (distance  < 0.8) {
		if (random.RandF() > 0.5) {
			handler.RightOffense();	
			handler.Forward();
		} else {
			handler.LeftOffense();	
			handler.Right();
		}
		return;	
	}

	if (distance < 1.0) {
		handler.Back();
		return;		
	}

	if (distance > 1.0 && distance < 1.1) {
		if (random.RandF() > 0.4) {
			handler.RightOffense();	
			handler.Back();
		} else {
			handler.LeftOffense();	
			handler.Back();
		}
		return;	
	}

	if (distance > 1.1 && distance < 1.2) {
		handler.Back();
		handler.RightOffense();	
		return;	
	}

	if (distance > 1.3 && distance < 1.4) {
		if (random.RandF() > 0.2) {
			handler.LeftOffense();	
		} else {
			handler.LeftOffense();	
			handler.Forward();			
		}
		return;	
	}
	
	if (distance > 1.4 && distance < 1.5) {
		if (random.RandF() > 0.3) {
			handler.RightOffense();
		} else {
			handler.LeftOffense();	
		}
		return;	
	}

	if (random.RandF() > 0.9) {
		handler.Left();	
	} else {
		handler.Right();	
	}
}


void Game::GetCom2States(BoxerHandler &handler) {
	handler.InitKey();

	if (handler.IsDownState()) {
		handler.Defense();
		return;
	}

	if (handler.IsWaitState()) {
		if (match.KOCount() - handler.Count() < 2) {
			handler.Defense();
		}
		return;
	}

	if (handler.IsMoving()) {
		if (random.RandF() > 0.10) {
		 	return;
		}
	}

	if (random.RandF() > 0.90) {
		if (random.RandF() > 0.5) {
			handler.Forward();	
		} else {
			handler.Back();
		}	
		return;	
	}

	if (handler.MoveSpeed() > 1.9) {
		handler.Back();
		return;	
	}

	if (handler.SwingSpeed() > 1.6) {
		if (random.RandF() > 0.666) {
			handler.Defense();
		} else if (random.RandF() > 0.5) {
			if (distance < 1.0) {
				handler.Defense();
				handler.Forward();
			} else {
				handler.Defense();
				handler.Back();
			}		
		} else {
				handler.Back();		
		}
		return;	
	}

	if (distance > 1.0) {
		handler.Forward();
		return;		
	}

	if (distance  < 0.75) {
		handler.LeftOffense();	
		handler.RightOffense();	
		return;
	}

	if (distance  < 0.8) {
		if (random.RandF() > 0.5) {
			handler.LeftOffense();	
		} else {
			handler.RightOffense();	
		}
		return;	
	}

	if (distance < 1.0) {
		handler.Back();
		return;		
	}

	if (distance > 1.0 && distance < 1.1) {
		if (random.RandF() > 0.4) {
			handler.LeftOffense();	
		} else {
			handler.RightOffense();
		}
		return;	
	}

	if (distance > 1.1 && distance < 1.2) {
			handler.RightOffense();
		return;	
	}

	if (distance > 1.3 && distance < 1.4) {
		if (random.RandF() > 0.2) {
			handler.LeftOffense();	
		} else {
			handler.LeftOffense();	
			handler.Forward();			
		}
		return;	
	}
	
	if (distance > 1.4 && distance < 1.5) {
		if (random.RandF() > 0.3) {
			handler.RightOffense();
		} else {
			handler.LeftOffense();	
		}
		return;	
	}

	if (random.RandF() > 0.9) {
		handler.Left();	
	} else {
		handler.Right();	
	}
}

bool Game::LoadBoxer(BoxerHandler &handler, Boxer &boxer, MotionHandler &motion, const char *filename) {
	if (handler.LoadBoxer(boxer, motion, filename) == SDL_FAILURE) {
		switch (lang) {
			case Kana:
				ttext.Pause("{NT[f[^t@C܂", 0.25);
			break;
			case English:
				ttext.Pause("Something is wrong about boxer data file.", 0.25);
			break;
			default:
				ttext.Pause("{NT[f[^t@C܂B", 0.25);
				break;
		}
		emes("Game::LoadBoxer -> Something wrong about boxer data file.");								
		return false;
	}
	return true;
}


bool Game::LoadThink(BoxerHandler &handler, const char *filename) {
 	CReader breader;

	if (breader.Open(filename) == SDL_FAILURE) {
		return false;	
	}
	if (handler.LoadBoxerThink(breader) == SDL_FAILURE) {
		return false;	
	}
	return true;
}

void Game::ChangeThink1() {
	if (can_change_mode1) {
		if ((use_mouse == 1 && FaceClicked(1)) ||
			event.IsKeyDown(kb1_forward)) {
			which_select = 1;
		}
	}
	if (handler1.WhichMode() == FULL_AUTO && handler2.WhichMode() == FULL_AUTO) {
		if ((use_mouse == 1 && event.IsMouse3Down()) ||
			event.IsKeyDown(kb1_right_offense)) {
			if(treble_mode) {
				treble_mode = 0;			
			} else {
				treble_mode = 15;							
			}
		}
		if (event.IsKeyDown(kb1_left_offense)) {
			treble_mode -= 3;
			if(treble_mode < 0) {
				treble_mode = 0;			
			}
		}
		if (event.IsKeyDown(kb1_defense)) {
			treble_mode += 3;
			if(treble_mode > 15) {
				treble_mode = 15;			
			}
		}
	}	
}
					
void Game::ChangeThink2() {
	if (can_change_mode2) {
		if ((use_mouse == 2 && FaceClicked(2)) ||
			event.IsKeyDown(kb2_back)) {
			which_select = 2;
		}
	}				
	if (handler1.WhichMode() == FULL_AUTO && handler2.WhichMode() == FULL_AUTO) {
		if ((use_mouse == 2 && event.IsMouse3Down()) ||
			event.IsKeyDown(kb2_right_offense)) {
			if(treble_mode) {
				treble_mode = 0;			
			} else {
				treble_mode = 15;							
			}
		}			
		if (event.IsKeyDown(kb2_left_offense)) {
			treble_mode -= 3;
			if(treble_mode < 0) {
				treble_mode = 0;			
			}
		}
		if (event.IsKeyDown(kb2_defense)) {
			treble_mode += 3;
			if(treble_mode > 15) {
				treble_mode = 15;			
			}
		}
	}	
}

bool Game::FaceClicked(int which) {
	static int x, y;
	SDL_GetMouseState(&x, &y);
	if (!which_select && !match.IsEnd() && event.IsMouse1Pressed()) {
		if (height* 0.05 < y && height* 0.25 > y &&
			width * 0.05 < x && width * 0.20 > x) {
			if (which == 2 && IsView1()) {
				return true;		
			}
			if (which == 1 && IsView2()) {
				return true;		
			}
		}	
		if (height* 0.05 < y && height* 0.25 > y &&
			width * 0.80 < x && width * 0.95 > x) {
			if (which == 2 && IsView2()) {
				return true;		
			}
			if (which == 1 && IsView1()) {
				return true;		
			}
		}
	}
	return false;	
}

void Game::SelectThink(BoxerHandler &handler, int select) {
	static int i, key_select = 0;
	static int x, y, loop, mouse_select = -1;
	static float size, csize;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	light.Set();
	SelectView();
	light2.Diffuse(0.0, 0.0, 0.0);
	light2.Set();

	if (BackGroundSwitch) {
		glbg.Show();
	}
	glring.Show(cxp, cyp, czp);

	csize =	(0.9 + 0.1 * sin(RAD(3*loop++)));
	SDL_GetMouseState(&x, &y);
	mouse_select = -1;
	if (width * 0.25 < x && width * 0.75 > x) {
		for (i = 0; i <= ThinkNumber; i++) {
			if (height* (0.20 + i * 0.048) < y &&
				height* (0.20 + (i+1) * 0.048) > y) {
				mouse_select = i;
			}
		}
	}

	if (select == 1) {
		if (event.IsKeyDown(kb1_right)) {
			key_select--;
			if (key_select < 0) {
				key_select = 0;		
			}
		}
		if (event.IsKeyDown(kb1_left)) {
			key_select++;
			if (key_select > ThinkNumber) {
				key_select = ThinkNumber;		
			}
		}
		if (event.IsKeyDown(kb1_back)) {
			if (key_select) {
				if (!LoadThink(handler, ThinkFiles[key_select])) {
					handler.LoadDefaultThink();					
				}			
			} else {
				handler.LoadDefaultThink();			
			}
			which_select = 0;
		}	
	} else {
		if (event.IsKeyDown(kb2_left)) {
			key_select--;
			if (key_select < 0) {
				key_select = 0;		
			}
		}
		if (event.IsKeyDown(kb2_right)) {
			key_select++;
			if (key_select > ThinkNumber) {
				key_select = ThinkNumber;		
			}
		}
		if (event.IsKeyDown(kb2_forward)) {
			if (key_select) {
				if (!LoadThink(handler, ThinkFiles[key_select])) {
					handler.LoadDefaultThink();					
				}			
			} else {
				handler.LoadDefaultThink();			
			}
			which_select = 0;
		}	
	}

	if (event.IsMouse1Down() && use_mouse == which_select) {
		if (mouse_select >= 0 && mouse_select <= ThinkNumber) {
			if (mouse_select) {
				if (!LoadThink(handler, ThinkFiles[mouse_select])) {
					handler.LoadDefaultThink();					
				}			
			} else {
				handler.LoadDefaultThink();			
			}
			key_select = mouse_select;
			which_select = 0;
		}
	}

	ttext.MessageEnter();	
	switch (lang) {
		case Kana:
			ttext.Print("t@C񂽂", 0.35, 0, 80);
		break;
		case English:
			ttext.Print("File Select", 0.35, 0, 80);
		break;
		default:
			ttext.Print("t@CI", 0.35, 0, 80);
		break;
	}
	for (i = 0; i <= ThinkNumber; i++) {
		key_select == i ? size = csize : size = 1.0;
		ttext.SelectColor(mouse_select == i);
	 	ttext.Print(ThinkFiles[i], 0.25*size, 0, 60 - i * 10);
	}
	ttext.SetColor(1.0, 1.0, 1.0);	
 	ttext.Print(timer.FPSString(), 0.25, 100, -100);
	ttext.MessageLeave();

 	SDL_GL_SwapBuffers(); 
	GLmes();
	timer.Wait();
	SetBrightness();
}


int Game::SelectStop(int select_type) {
	static char *menu_kanji[] = {"ĊJ", "^I", "f"};
	static char *menu_kana[] = {"", "^IȂ", "イ"};
	static char *menu_english[] = {"Resume", "Throw in the towel", "Interruption"};

	static int i, select, key_select = 0;
	static int max_select, min_select;
	static int x, y, loop, mouse_select = -1;
	static float size, csize;
	
	select = -1;	
	min_select = 1;

	switch (select_type) {
		case SELECT_STORY_COM:
		case SELECT_STORY_RED:
		case SELECT_STORY_BLUE:
			max_select = 1;		
		break;
		case SELECT_1PSPARRING:
		case SELECT_2PMATCH:
			max_select = 3;		
		break;
	}

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	light.Set();
	SelectView();
	light2.Diffuse(0.0, 0.0, 0.0);
	light2.Set();

	if (BackGroundSwitch) {
		glbg.Show();
	}
	glring.Show(cxp, cyp, czp);

	SDL_GetMouseState(&x, &y);
	mouse_select = -1;
	if (width*0.25  < x && width*0.75 > x) {
		for (i = min_select-1; i < max_select; i++) {
			if (height*(0.15 + (float)i*0.09) < y &&
				height*(0.24 + (float)i*0.09) > y) {
   		    	mouse_select = i;
			}
		}
	}

	if (event.IsKeyDown(kb2_left) ||  
		event.IsKeyDown(kb2_forward)) {  
		if (key_select > min_select-1) {
			key_select--;
		}
	}
	if (event.IsKeyDown(kb2_right) ||  
		event.IsKeyDown(kb2_back)) {  
		if (key_select < max_select-1) {
			key_select++;
		}
	}

	csize =	(1.0 + 0.2 * sin(RAD(2*loop++)));

	ttext.MessageEnter();
	for (i = 0; i < max_select; i++) {
		ttext.SelectColor(mouse_select == i);
		key_select == i ? size = csize : size = 1.0;
		switch (lang) {
			case Kana:
				ttext.Print(menu_kana[i], 0.5 * size, 0, 70 - i*20);
			break;
			case English:
				ttext.Print(menu_english[i], 0.5 * size, 0, 70 - i*20);
			break;
			default:
				ttext.Print(menu_kanji[i], 0.5 * size, 0, 70 - i*20);
			break;
		}
	}

	ttext.SetColor(1.0, 1.0, 1.0);	
  	ttext.Print(timer.FPSString(), 0.25, 100, -100);
	ttext.MessageLeave();

	if (event.IsKeyDown(go_next)) {
		select = key_select;
	}
	if (mouse_select != -1 && event.IsMouse1Down()) {
		select = mouse_select;
	}

 	SDL_GL_SwapBuffers(); 
	GLmes();
	timer.Wait();
	SetBrightness();

	if (select != -1) {
		key_select = 0;
		which_select = 0;
	}

	return select;
}

void Game::ThrowIn(int select_type) {
	match.End();
	mixer.PlayChunk(SE_KO);
	switch (select_type) {
		case RED_WON_TKO :
			match.RedWonbyTKO();		
		break;
		case BLUE_WON_TKO :
		case SELECT_1PSPARRING :
			match.BlueWonbyTKO();		
		break;
		case SELECT_2PMATCH :
			match.DKODraw();		
		break;
		case NO_CONTEST :
			match.NoContest();
		break;
	}
	match.SetLatestRound();
	handler1.SaveThrowInState(match.TimeCount(), INVALID_KEY);
	handler2.SaveThrowInState(match.TimeCount(), match.ResultState());
}					

void Game::ShowNext() {
	static int x, y;
	next = 0;
	SDL_GetMouseState(&x, &y);
	if (height* 0.95 < y && height* 1.00 > y &&
		width * 0.00 < x && width * 0.07 > x) {
		ttext.SetColor(1.0, 0.0, 0.0);	
		if (event.IsMouse1Down()) {
			next = 1;
		}
	} else {
		ttext.SetColor(1.0, 1.0, 1.0);	
	}
	ttext.Print("Next", 0.25, -100, -100);
	ttext.SetColor(1.0, 1.0, 1.0);	
}

void Game::ShowStop() {
	static int x, y;
	stop = 0;
	SDL_GetMouseState(&x, &y);
	if (height* 0.95 < y && height* 1.00 > y &&
		width * 0.00 < x && width * 0.07 > x) {
		ttext.SetColor(1.0, 0.0, 0.0);	
		if (event.IsMouse1Down()) {
			stop = 1;
		}
	} else {
		ttext.SetColor(1.0, 1.0, 1.0);	
	}
	ttext.Print("Stop", 0.25, -100, -100);
	ttext.SetColor(1.0, 1.0, 1.0);	
}
