#ifndef GLBACKGROUND_H
#define GLBACKGROUND_H

#include "myglheader.h"
#include "glshapes.h"
#include "gldlist.h"
#include "glmaterial.h"
#include "glmatrix.h"
#include "gltexture.h"

class GLBackGround {
public:
	GLBackGround() : glbackground(false) {}
	~GLBackGround() {}
	void Show();
	void Make(GLTexture &background_tex, GLTexture &floor_tex, GLTexture &roof_tex, int pattern = 1, int partition = 36);
private:
	GLDList glbackground;
};

#endif /// GLBACKGROUND_H
