#ifndef GLDLIST_H
#define GLDLIST_H

#include "csdl.h"

class GLDList {
public:
	GLDList(bool gen = true);
	~GLDList() {Delete();}
	int Generate();
	void Delete();
	void NewList(GLenum mode = GL_COMPILE) {glNewList(dlname, mode);}
 	void EndList() {glEndList();}
	void CallList() {glCallList(dlname);}
	bool WasGenerate();
private:
	GLuint dlname;
};

class GLDLists {
public:
	GLDLists();
	~GLDLists() {Delete();}
	int Generate(int number);
	void Delete();
	void Delete(int number);
	void Choice(int number);
	void NewList(GLenum mode = GL_COMPILE);
	void NewList(int number, GLenum mode = GL_COMPILE);
	void EndList() {glEndList();} 
	void CallList() {glCallList(dlname + cnumber);}
	void CallList(int number);
	void operator[](int number) {CallList(number);}
	bool WasGenerate(int number);
	bool WasGenerate();
private:
	int mnumber;
	int cnumber;
	GLuint dlname;
};

#endif // GLDLIST_H
