#ifndef MYGLHEADER
#define MYGLHEADER

#include <SDL_opengl.h> // wb_[t@C

/* ͂Ƃ */
#ifndef	__VISUALC__
#define SWAP_INTERVAL_OFF
#endif
#ifdef SWAP_INTERVAL_OFF
typedef void (*wglSwapIntervalEXT_FUNC) (unsigned int);
#endif 

/* vݒ */
#define REQUIRED32_RED_SIZE 8
#define REQUIRED32_GREEN_SIZE 8
#define REQUIRED32_BLUE_SIZE 8
#define REQUIRED32_ALPHA_SIZE 8
#define REQUIRED16_RED_SIZE 5 
#define REQUIRED16_GREEN_SIZE 6
#define REQUIRED16_BLUE_SIZE 5
#define REQUIRED16_ALPHA_SIZE 0
#define REQUIRED_DEPTH_SIZE 16
#define REQUIRED_DOUBLEBUFFER 1

const GLfloat NO_MOVE = 1.0e10;
const GLfloat NO_CHANGE = -1.0;
const GLfloat VERY_SMALL = 1.0e-6;
const GLfloat VERY_BIG = 1.0e6;

/* G[擾p}N */
#define	GLmes() {\
	GLenum errorCode = glGetError();\
		if (errorCode != GL_NO_ERROR) {\
			fprintf(stderr, "OpenGL ERROR : %s, in file: %s, lines %d\n",\
			gluErrorString(errorCode), __FILE__, __LINE__);\
		}\
}

#ifdef DEBUG
#define	GLmesBebug() {\
	GLenum errorCode = glGetError();\
		if (errorCode != GL_NO_ERROR) {\
			fprintf(stderr, "OpenGL ERROR : %s, in file: %s, lines %d\n",\
			gluErrorString(errorCode), __FILE__, __LINE__);\
		}\
}
#else
#define	GLmesBebug()
#endif

#endif
