#ifndef RANDOM_H
#define RANDOM_H

#include "csdl.h"
#include <time.h>
#include <math.h>

class Random {
public:
	Random();
	int Rand() const {return rand();}	
	int Rand(int min_value, int max_value) const;
	int Rand(int max_value) const {return Rand() % (max_value+1);}
	int RandN(int value, float omega);
	int RandSN(int value, float omega);
	int Percent() const {return rand() % 101;}	
	float RandF() const {return (float)rand()/(float)(RAND_MAX);}	
	void SetSeed(Uint32 cseed);
	Uint32 GetSeed() const {return seed;}
	void Reset() {srand(seed);}
	void Test1();
	void Test2();	
private:
	Uint32 seed;		
};

#endif // RANDOM_H
