#ifndef STORYMATCH_H
#define STORYMATCH_H

class StoryMatch {
public:
	StoryMatch();
	~StoryMatch();
		
	void Init();
	int HighRanked() const {return high_ranked;}
	int LowRanked() const {return low_ranked;}
	int MachType() const {return match_type;}

	void SetHighRanked(int i) {high_ranked = i;}
	void SetLowRanked(int i) {low_ranked = i;}
	void SetMatchType(int i) {match_type = i;}

	bool Save();
	bool Load();

private:
	int high_ranked;
	int low_ranked;
	int match_type;
};

class Challenger {
public:
	Challenger(){}
	~Challenger(){}
		
private:
	int challengers[5];
};

#endif // STORYMATCH_H

