#ifndef BOXERPAGE_H
#define BOXERPAGE_H

#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/combobox.h>
#include "myslider.h"
#include "mylabel.h"
#include "mycbox.h"
#include "mytctrl.h"
#include "myfileselect.h"

class BoxerPage : public wxScrolledWindow {
public:
    BoxerPage(wxWindow* parent);

	void SetDefault();

	bool SaveDataCf(wxTextOutputStream &out);
	bool SaveData();
	bool LoadDataCf(wxTextInputStream &in);
	bool LoadData();

private:
    void SetProperties();
    void DoLayout();
	void OnSelect(wxCommandEvent& event);

	myLabel *labelf;
	myFileSelect *DataCf;

	myButton *label[30];
	myFileSelect *Data[30];
	
	int Custom1[9];
	int Custom2[9];

	DECLARE_EVENT_TABLE()
};

#endif // BOXERPAGE_H
