#ifndef CREADER_H
#define CREADER_H

#include "csdl.h"
                      
#define MAX_FILE_SIZE 65536*4
#define MAX_LINE_SIZE 255

typedef struct {
	int len;
	char *cp;
} LINE;

/* ݒǂݍݗp */
class CReader {
public:
	CReader();
	CReader(const char* filename);
	~CReader();
	int Open(const char* filename);
	int OpenFrom(char* data, int size);
	void Close();
	void MakeLines();
	void Skip();
	int NextInt();
	float NextIntF(int number = 1000);
	float NextFloat();
	void NextChar(char* filename);	
	void NextLine(char* filename);	

	void NextLine();	
	char* CurrentLine();	
	char* CurrentPos() {return cp;}	
	char* GetLine(int number);	

	void Rewind();	
	void Back(int number);	
	void Print();	

	int FileSize() const {return filesize;}
	int MaxNumber() const {return mnumber;}
	int CurrentNumber() const {return cnumber;}	
	bool IsLast() {return is_last;}
	bool WasOpen();       
private:
	char *buf;
	char *cp;
	char line[MAX_LINE_SIZE];
    int filesize;
	int mnumber;
	int cnumber;
	LINE *lines;
	bool is_last;
};

#endif // CREADER_H
