/*
	̃vO
	http://astronomy.swin.edu.au/~pbourke/modelling/polygonise/
	http://www.media.t-kougei.ac.jp/~nagae/pub/94/thesis/
	Ȃǂ̃TCgQlɂč܂Bby P`
*/

#ifndef GLPOLYGONIZE_H
#define GLPOLYGONIZE_H

//#define USE_GFX_FONT  //SDL_gfx̃tHggꍇ
#include "csdl.h"

enum {
	X = 0,
	Y,
	Z,
	F,
	RX,
	RY,
	RZ
};

class GLPolygonize {
public:
	GLPolygonize();
	~GLPolygonize();
	int Make(int im, int jm, int km, float xs, float ys, float zs, float xl, float yl, float zl, float (func)(int, int, int));
	int MakeAT(int im, int jm, int km, float xs, float ys, float zs, float xl, float yl, float zl, float (func)(int, int, int));
	void Alphabet(char c);
	void Surface(SDL_Surface *surface);
private:
	void make_table();
	void make_edge_x(float *edge, float *edgen, float *p1, float *p2);
	void make_edge_y(float *edge, float *edgen, float *p1, float *p2);
	void make_edge_z(float *edge, float *edgen, float *p1, float *p2);
	int edge_index_table[256][13];
	int polygon_index_table[256][17];
	float threshold;
	float f[128][128][4];
};

#endif //GLPOLYGONIZE
