#ifndef SSURFACE_H
#define SSURFACE_H

#include "csdl.h"
#include <SDL_image.h>

class SSurface {
public:
	SSurface();
	~SSurface();
	int Load(const char *file);	
	void Free();
	SDL_Surface* Get();
	void Set(SDL_Surface* set_surf);
	void Cls();
	int Blit(SDL_Surface* blit_surf, int x, int y);
	int Blit(SSurface blit_surf, int x, int y);
	bool WasCreate();
protected:
	SDL_Surface *surface;
};

class SSurfaces {
public:
	SSurfaces();
	~SSurfaces();
	int Init(int number);	
	void Free();
	SDL_Surface* Get();
	SDL_Surface* Get(int number);
	void Set(SDL_Surface* set_surf);
	void Set(int number, SDL_Surface* set_surf);
	int Load(const char *file);
	int Load(int number, const char *file);
	void Choice(int number);
	void operator[](int number);
	bool WasCreate();
	bool WasCreate(int number);
	bool WasInit();
private:
	SSurface *surfaces;
	int mnumber;
	int cnumber;
};

#endif // SSURFACE_H
