#ifndef THINK_H
#define THINK_H

enum {
	TR_NOTHING,
	TR_FORWARD,
	TR_BACK,
	TR_RIGHT,
	TR_LEFT,
	TR_RIGHT_N,
	TR_RIGHT_F,
	TR_RIGHT_B,
	TR_RIGHT_R,
	TR_RIGHT_L,
	TR_RIGHT_RF,
	TR_RIGHT_LF,
	TR_RIGHT_RB,
	TR_RIGHT_LB,
	TR_LEFT_N,
	TR_LEFT_F,
	TR_LEFT_B,
	TR_LEFT_R,
	TR_LEFT_L,
	TR_LEFT_RF,
	TR_LEFT_LF,
	TR_LEFT_RB,
	TR_LEFT_LB,
	TR_DEFENSE_N,
	TR_DEFENSE_F,
	TR_DEFENSE_B,
	TR_DEFENSE_R,
	TR_DEFENSE_L,
	TR_DEFENSE_RF,
	TR_DEFENSE_LF,
	TR_DEFENSE_RB,
	TR_DEFENSE_LB,
	TR_CLINCH,
	TR_DEADLY,
	TR_MOVE_RANDOM,
	TR_R_OFFENSE_RANDOM,
	TR_L_OFFENSE_RANDOM,
	TR_DEFENSE_RANDOM,
	TR_THROUGH	
};

class Boxer;
class BoxerHandler;
class MatchHandler;

class Think {
public:
	Think(){}
	~Think(){}
	int Consider(MatchHandler &match, BoxerHandler& m_handler, Boxer &m_boxer, BoxerHandler& o_handler);
	int Select(int s_action);
	void Reverse();
	void Print(MatchHandler &match, BoxerHandler& m_handler, Boxer &m_boxer, BoxerHandler& o_handler);
private:
	int con_restround_less;
	int restround_less;	
	int con_resttime_less;
	int resttime_less;	

	int con_mrestcount_less;
	int mrestcount_less;	
	int con_mrestdown_less;
	int mrestdown_less;	

	int con_distance_greater;
	float distance_greater;
	int con_distance_less;
	float distance_less;
	int con_mposition;
	int mposition;	
	int con_msituation;
	int msituation;	

	int con_mswing_greater;
	float mswing_greater;
	int con_mswing_less;
	float mswing_less;
	int con_mspeed_greater;
	float mspeed_greater;
	int con_mspeed_less;
	float mspeed_less;
	int con_mstate;
	int mstate;

	int con_oswing_greater;
	float oswing_greater;
	int con_oswing_less;
	float oswing_less;
	int con_ospeed_greater;
	float ospeed_greater;
	int con_ospeed_less;
	float ospeed_less;
 	int con_ostate;
	int ostate;
	
	int action[5];
	int action_rate[5];
	friend class BoxerHandler;
};

#endif // THINK_H
